function string.split(txt,d)
	if not d then d = " " end;
	local split = {};
	local lastPos = 1;
	for i = 1, string.len(txt) + 1 do
		if string.sub(txt, i, i + string.len(d) - 1) == d or i == string.len(txt) + 1 then
			local newSplit = string.sub(txt, lastPos, i - 1);
			table.insert(split, newSplit);
			lastPos = i + string.len(d);
		end
	end
	return split;
end

entity_type = {
	["t"] 					= 0;
	["ct"] 					= 1;
	["vip"] 				= 2;
	["hostage"] 			= 3;
	["rescuepoint"] 		= 4;
	["bombspot"]			= 5;
	["escapepoint"]			= 6;
	["animation"]			= 8;
	["storm"]				= 9;
	["tilefx"]				= 10;
	["nobuying"]			= 11;
	["noweapons"]			= 12;
	["nofow"]				= 13;
	["quake"]				= 14;
	["ctf_flag"]			= 15;
	["oldrender"]			= 16;
	["dom_point"]			= 17;
	["nobuildings"]			= 18;
	["botnode"]				= 19;
	["teamgate"]			= 20;
	["item"] 				= 21;
	["sprite"]				= 22;
	["sound"]				= 23;
	["decal"]				= 24;
	["breakable"]			= 25;
	["explode"]				= 26;
	["hurt"]				= 27;
	["image"]				= 28;
	["object"]				= 29;
	["building"]			= 30;
	["npc"]					= 31;
	["room"]				= 32;
	["light"]				= 33;
	["lightstripe"]			= 34;
	
	["particles"]			= 50;
	["sprites"]				= 51;
	["weather"]				= 52;
	
	["teleport"]			= 70;
	["dynwall"]				= 71;
	["message"]				= 72;
	["gameaction"]			= 73;
	
	["start"]				= 90;
	["move"]				= 91;
	["hit"]					= 92;
	["use"]					= 93;
	["delay"]				= 94;
	["once"]				= 95;
}
object_type = {
	["palm"] 				= 0;
	["tree"] 				= 1;
	["alarm"] 				= 2;
	["sink"] 				= 3;
	["toilet"] 				= 4;
	["streetlight"]			= 5;
	["streetlightflicker"]	= 6;
}

function LoadMap(name) return Generator.LoadMap(name) end
function SaveMap(name) return Generator.SaveMap(name) end
function SetTile(X, Y, Tile) return Generator.SetTile(X, Y, Tile) end
function EntityTypeID(name)
	local name = string.lower(name);
	if entity_type[name] then return entity_type[name] end
	return -1;
end
function ObjectTypeID(name)
	local name = string.lower(name);
	if object_type[name] then return object_type[name] end
	return -1;
end
function GetEntityList()
	local entities = {}
	local ret = string.split(Generator.GetEntityList(), "|");
	local entitycount = tonumber(ret[1]);
	local i, j, x;
	local ent;
	i = 1;
	for x = 1, entitycount do
		ent = {};
		i=i+1; ent.name = ret[i];
		i=i+1; ent.type = tonumber(ret[i]);
		i=i+1; ent.x = tonumber(ret[i]);
		i=i+1; ent.y = tonumber(ret[i]);
		i=i+1; ent.trigger = ret[i];
		ent.int = {};
		ent.str = {};
		for j = 1, 10 do
			i=i+1; ent.int[j] = tonumber(ret[i]);
			i=i+1; ent.str[j] = ret[i];
		end
		table.insert(entities, ent);
	end
	return entities
end
function SetEntityList(list)
	local str = "";
	str = str .. #list;
	local _, i, j;
	for _, i in pairs(list) do
		str = str .. "|" .. i.name;
		str = str .. "|" .. i.type;
		str = str .. "|" .. i.x;
		str = str .. "|" .. i.y;
		str = str .. "|" .. i.trigger;
		for j = 1, 10 do
			str = str .. "|" .. i.int[j];
			str = str .. "|" .. i.str[j];
		end
	end
	Generator.SetEntityList(str);
end
function Map(prop)
	return Generator._Map(prop);
end
function MapSet(prop, val)
	return Generator._MapSet(prop, val);
end
function GetTile(X, Y)
	return Generator.GetTile(X, Y);
end
function SetTileModifier(X, Y, modifier)
	return Generator.SetTileModifier(X, Y, modifier);
end
function GetTileModifier(X, Y)
	return Generator.GetTileModifier(X, Y);
end
function SetTileData(X, Y, data, val)
	return Generator.SetTileData(X, Y, data, val);
end
function GetTileData(X, Y, data)
	return Generator.GetTileData(X, Y, data);
end
function CreateMap(W, H, blending)
	Generator._CreateMap(W, H, blending);
end
function SetMapSize(W, H)
	Generator.SetMapSize(W, H);
end